# Airtime - Live Broadcast Together (ready for nginx + PHP 7)

Fork of Airtime application that provides remote automation of a broadcast radio station. Some parts of code were fixed, so that application works well in combination of nginx and PHP 7. API Client now supports connecting to HTTPS, so you can easily setup application with HTTPS protocol instead of HTTP. It also includes configurations for Ubuntu Server 16.04 packages and nginx virtual block. Application is stable and ready to use, but I recommend you to make full test before use in production if there is still any bug. The code was forked from [official Github repository], 2.5.x branch and once installed, it's marked as Airtime 2.5.2. Application was made by [Sourcefabric] and is except the fixes to be compatibile with nginx and PHP 7, unchanged.

### Installation

Installation script supports install of nginx instead of Apache. Script is ready for use and was tested on Ubuntu 16.04, so it probably also works well with Debian (it may need some customizations). If you're using Ubuntu make sure you're using latest PHP (not really a requirement, but more a recommendation) and install mp3gain package (currently not in Ubuntu repositories) ...
```
sudo add-apt-repository ppa:ondrej/php
sudo add-apt-repository ppa:flexiondotorg/audio
sudo apt-get update
```

Basic install with verbose output (for more customized install) ...

For Bash users:
```
sudo ./install -vpnir /etc/airtime/
```

And non-Bash users:
```
sudo /bin/bash ./install -vpnir /etc/airtime/
```

Afterwards you need to change nginx or php-fpm7.0 config to be consistent with the other one. Default nginx virtual block config which is installed with script contains TCP/IP connection (127.0.0.1:9000) to php-fpm, so either change Unix socket (which is used by default) to TCP/IP or nginx virtual block config to appropriate Unix socket (which you can find in php-fpm config, located `/etc/php/7.0/fpm/pool.d/www.conf` by default).

### License

The software is provided "as is", without warranty of any kind from my side. All files in project are included as fetched from source and may have been changed in the way to make things work with technologies specified above. Please read original license which is added to the project if you want to further use this software or modify it. All respective rights reserved to authors and contributors.

   [official Github repository]: <https://github.com/sourcefabric/airtime>
   [Sourcefabric]: <https://www.sourcefabric.org/en/airtime/>
